# all files / ol/layer/ layerbase.js

100% Statements 56/56
100% Branches 10/10
100% Functions 14/14
100% Lines 56/56

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    2621×
    1×
    1×

    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×

    338×

    338×
    338×

    338×

    338×

    338×

    338×

    338×

    1×

    1×
    190×
    190×
    190×
    190×
    190×
    190×
    190×
    190×

    1×

    1×

    1×
    192×

    1×
    194×

    1×
    194×

    1×
    196×

    1×

    1×
    233×

    1×
    190×

    1×
    1×

    1×
    6×

    1×
    6×

    1×
    10×

    1×
    18×

    1×
    4×

     goog.provide('ol.layer.Base');
    goog.provide('ol.layer.LayerProperty');
    goog.provide('ol.layer.LayerState');

    goog.require('goog.object');
    goog.require('ol');
    goog.require('ol.Object');
    goog.require('ol.math');
    goog.require('ol.source.State');

    /**
     * @enum {string}
     */
    ol.layer.LayerProperty = {
      OPACITY: 'opacity',
      VISIBLE: 'visible',
      EXTENT: 'extent',
      Z_INDEX: 'zIndex',
      MAX_RESOLUTION: 'maxResolution',
      MIN_RESOLUTION: 'minResolution',
      SOURCE: 'source'
    };

    /**
     * @typedef {{layer: ol.layer.Layer,
     *            opacity: number,
     *            sourceState: ol.source.State,
     *            visible: boolean,
     *            managed: boolean,
     *            extent: (ol.Extent|undefined),
     *            zIndex: number,
     *            maxResolution: number,
     *            minResolution: number}}
     */
    ol.layer.LayerState;

    /**
     * @classdesc
     * Abstract base class; normally only used for creating subclasses and not
     * instantiated in apps.
     * Note that with `ol.layer.Base` and all its subclasses, any property set in
     * the options is set as a {@link ol.Object} property on the layer object, so
     * is observable, and has get/set accessors.
     *
     * @constructor
     * @extends {ol.Object}
     * @param {olx.layer.BaseOptions} options Layer options.
     * @api stable
     */
    ol.layer.Base = function(options) {

      goog.base(this);

      /**
       * @type {Object.<string, *>}
       */
      var properties = goog.object.clone(options);
      properties[ol.layer.LayerProperty.OPACITY] =
          options.opacity !== undefined ? options.opacity : 1;
      properties[ol.layer.LayerProperty.VISIBLE] =
          options.visible !== undefined ? options.visible : true;
      properties[ol.layer.LayerProperty.Z_INDEX] =
          options.zIndex !== undefined ? options.zIndex : 0;
      properties[ol.layer.LayerProperty.MAX_RESOLUTION] =
          options.maxResolution !== undefined ? options.maxResolution : Infinity;
      properties[ol.layer.LayerProperty.MIN_RESOLUTION] =
          options.minResolution !== undefined ? options.minResolution : 0;

      this.setProperties(properties);
    };
    goog.inherits(ol.layer.Base, ol.Object);

    /**
     * @return {ol.layer.LayerState} Layer state.
     */
    ol.layer.Base.prototype.getLayerState = function() {
      var opacity = this.getOpacity();
      var sourceState = this.getSourceState();
      var visible = this.getVisible();
      var extent = this.getExtent();
      var zIndex = this.getZIndex();
      var maxResolution = this.getMaxResolution();
      var minResolution = this.getMinResolution();
      return {
        layer: /** @type {ol.layer.Layer} */ (this),
        opacity: ol.math.clamp(opacity, 0, 1),
        sourceState: sourceState,
        visible: visible,
        managed: true,
        extent: extent,
        zIndex: zIndex,
        maxResolution: maxResolution,
        minResolution: Math.max(minResolution, 0)
      };
    };

    /**
     * @param {Array.<ol.layer.Layer>=} opt_array Array of layers (to be
     *     modified in place).
     * @return {Array.<ol.layer.Layer>} Array of layers.
     */
    ol.layer.Base.prototype.getLayersArray = goog.abstractMethod;

    /**
     * @param {Array.<ol.layer.LayerState>=} opt_states Optional list of layer
     *     states (to be modified in place).
     * @return {Array.<ol.layer.LayerState>} List of layer states.
     */
    ol.layer.Base.prototype.getLayerStatesArray = goog.abstractMethod;

    /**
     * Return the {@link ol.Extent extent} of the layer or `undefined` if it
     * will be visible regardless of extent.
     * @return {ol.Extent|undefined} The layer extent.
     * @observable
     * @api stable
     */
    ol.layer.Base.prototype.getExtent = function() {
      return /** @type {ol.Extent|undefined} */ (
          this.get(ol.layer.LayerProperty.EXTENT));
    };

    /**
     * Return the maximum resolution of the layer.
     * @return {number} The maximum resolution of the layer.
     * @observable
     * @api stable
     */
    ol.layer.Base.prototype.getMaxResolution = function() {
      return /** @type {number} */ (
          this.get(ol.layer.LayerProperty.MAX_RESOLUTION));
    };

    /**
     * Return the minimum resolution of the layer.
     * @return {number} The minimum resolution of the layer.
     * @observable
     * @api stable
     */
    ol.layer.Base.prototype.getMinResolution = function() {
      return /** @type {number} */ (
          this.get(ol.layer.LayerProperty.MIN_RESOLUTION));
    };

    /**
     * Return the opacity of the layer (between 0 and 1).
     * @return {number} The opacity of the layer.
     * @observable
     * @api stable
     */
    ol.layer.Base.prototype.getOpacity = function() {
      return /** @type {number} */ (this.get(ol.layer.LayerProperty.OPACITY));
    };

    /**
     * @return {ol.source.State} Source state.
     */
    ol.layer.Base.prototype.getSourceState = goog.abstractMethod;

    /**
     * Return the visibility of the layer (`true` or `false`).
     * @return {boolean} The visibility of the layer.
     * @observable
     * @api stable
     */
    ol.layer.Base.prototype.getVisible = function() {
      return /** @type {boolean} */ (this.get(ol.layer.LayerProperty.VISIBLE));
    };

    /**
     * Return the Z-index of the layer, which is used to order layers before
     * rendering. The default Z-index is 0.
     * @return {number} The Z-index of the layer.
     * @observable
     * @api
     */
    ol.layer.Base.prototype.getZIndex = function() {
      return /** @type {number} */ (this.get(ol.layer.LayerProperty.Z_INDEX));
    };

    /**
     * Set the extent at which the layer is visible.  If `undefined`, the layer
     * will be visible at all extents.
     * @param {ol.Extent|undefined} extent The extent of the layer.
     * @observable
     * @api stable
     */
    ol.layer.Base.prototype.setExtent = function(extent) {
      this.set(ol.layer.LayerProperty.EXTENT, extent);
    };

    /**
     * Set the maximum resolution at which the layer is visible.
     * @param {number} maxResolution The maximum resolution of the layer.
     * @observable
     * @api stable
     */
    ol.layer.Base.prototype.setMaxResolution = function(maxResolution) {
      this.set(ol.layer.LayerProperty.MAX_RESOLUTION, maxResolution);
    };

    /**
     * Set the minimum resolution at which the layer is visible.
     * @param {number} minResolution The minimum resolution of the layer.
     * @observable
     * @api stable
     */
    ol.layer.Base.prototype.setMinResolution = function(minResolution) {
      this.set(ol.layer.LayerProperty.MIN_RESOLUTION, minResolution);
    };

    /**
     * Set the opacity of the layer, allowed values range from 0 to 1.
     * @param {number} opacity The opacity of the layer.
     * @observable
     * @api stable
     */
    ol.layer.Base.prototype.setOpacity = function(opacity) {
      this.set(ol.layer.LayerProperty.OPACITY, opacity);
    };

    /**
     * Set the visibility of the layer (`true` or `false`).
     * @param {boolean} visible The visibility of the layer.
     * @observable
     * @api stable
     */
    ol.layer.Base.prototype.setVisible = function(visible) {
      this.set(ol.layer.LayerProperty.VISIBLE, visible);
    };

    /**
     * Set Z-index of the layer, which is used to order layers before rendering.
     * The default Z-index is 0.
     * @param {number} zindex The z-index of the layer.
     * @observable
     * @api
     */
    ol.layer.Base.prototype.setZIndex = function(zindex) {
      this.set(ol.layer.LayerProperty.Z_INDEX, zindex);
    };